std::linear_congruential_engine< _UIntType, __a, __c, __m >(3cxx)

NAME
std::linear_congruential_engine< _UIntType, __a, __c, __m > - A model of a linear congruential random number generator.

SYNOPSIS

  Public Types

typedef _UIntType result_type

  Public Member Functions

template<typename _Sseq , typename = typename std::enable_if<!std::is_same<_Sseq, linear_congruential_engine>::value> ::type> linear_congruential_engine (_Sseq &__q)
Constructs a linear_congruential_engine random number generator engine seeded from the seed sequence __q.
linear_congruential_engine (result_type __s=default_seed)
Constructs a linear_congruential_engine random number generator engine with seed __s. The default seed value is 1.
void discard (unsigned long long __z)
Discard a sequence of random numbers.
result_type operator() ()
Gets the next random number in the sequence.
template<typename _Sseq > std::enable_if< std::is_class< _Sseq >::value >::type seed (_Sseq &__q)
Reseeds the linear_congruential_engine random number generator engine sequence using values from the seed sequence __q.
void seed (result_type __s=default_seed)
Reseeds the linear_congruential_engine random number generator engine sequence to the seed __s.

  Static Public Member Functions

static constexpr result_type max ()
Gets the largest possible value in the output range.
static constexpr result_type min ()
Gets the smallest possible value in the output range.

  Static Public Attributes

static constexpr result_type default_seed
static constexpr result_type increment
static constexpr result_type modulus
static constexpr result_type multiplier

  Friends

template<typename _UIntType1 , _UIntType1 __a1, _UIntType1 __c1, _UIntType1 __m1, typename _CharT , typename _Traits > std::basic_ostream< _CharT, _Traits > & operator<< (std::basic_ostream< _CharT, _Traits > &__os, const std::linear_congruential_engine< _UIntType1, __a1, __c1, __m1 > &__lcr)
Writes the textual representation of the state x(i) of x to __os.
bool operator== (const linear_congruential_engine &__lhs, const linear_congruential_engine &__rhs)
Compares two linear congruential random number generator objects of the same type for equality.
template<typename _UIntType1 , _UIntType1 __a1, _UIntType1 __c1, _UIntType1 __m1, typename _CharT , typename _Traits > std::basic_istream< _CharT, _Traits > & operator>> (std::basic_istream< _CharT, _Traits > &__is, std::linear_congruential_engine< _UIntType1, __a1, __c1, __m1 > &__lcr)
Sets the state of the engine by reading its textual representation from __is.

Detailed Description

  template<typename _UIntType, _UIntType __a, _UIntType __c, _UIntType __m>
class std::linear_congruential_engine< _UIntType, __a, __c, __m >" A model of a linear congruential random number generator.

A random number generator that produces pseudorandom numbers via linear function:

The template parameter _UIntType must be an unsigned integral type large enough to store values up to (__m-1). If the template parameter __m is 0, the modulus __m used is std::numeric_limits<_UIntType>::max() plus 1. Otherwise, the template parameters __a and __c must be less than __m.

The size of the state is $1$.

Definition at line 229 of file random.h.

Author

Generated automatically by Doxygen for libstdc++ from the source code.